from videoClass import *
import skimage.io as io
import pickle
import time
from ramBhaiyaMatch import *

#COnvert images to uint8 to use in imshow and opencv cvtColor functions

#bg = GetBackground('test.mov')
bg = pickle.load(open( "tempBG.p", "rb"))

redFact = 0.25

#pickle.dump(bg, open("tempBG.p", "wb"))
#bg = pickle.load(open( "tempBG.p", "rb"))

graybg = cv2.cvtColor(bg, cv2.COLOR_BGR2GRAY)
    
graybg = cv2.resize(graybg, None, fx= redFact, fy=redFact)

io.imshow(graybg)
io.show()

#Method 1 : Simple Background subtraction

cap = VideoCapture('test.mov')
cap.open()

oldFrame = graybg

saveCount = 1

for i in range(100):
    ret, frame = cap.read()

cnt = 0

while True:
    ret, frame = cap.read()

    frame = cv2.resize(frame ,None, fx= redFact, fy=redFact)
    gray = cv2.cvtColor(frame, cv2.COLOR_BGR2GRAY)

    cv2.imshow('OrigGray',gray)
    cnt += 1

    t1 = time.time()

    # cv2.imwrite('tmpImage.jpg', gray)

    tmpFrame = cv2.absdiff(gray, graybg)
    imgA = tmpFrame

    imgC = match(tmpFrame, oldFrame)

    sift = cv2.SIFT()
    kp, sd = sift.detectAndCompute(np.array(tmpFrame), None)

    img=cv2.drawKeypoints(tmpFrame,kp)
    cv2.imshow('SIFTframe',img)
    imgB = img

    print 'Time taken is', time.time() - t1

    # print tmpFrame
    oldFrame = tmpFrame
    # frame[frame<0] = 0
    # tmpFrame = tmpFrame.astype(np.uint8)
    ret, tmpFrame = cv2.threshold(tmpFrame, 50, 255, cv2.THRESH_BINARY)			#THRESH_TOZERO, THRESH_BINARY and the INV possible options
    #color = cv2.cvtColor(frame, cv2.COLOR_BGR2GRAY)
    # cv2.imshow('binFrame',tmpFrame)

    key = cv2.waitKey(100) & 0xFF

    if key == ord('q'):
        break
    elif key == ord("s"):
        saveCount += 1
        print ("Saving the files to objTrack"), saveCount, '*.jpg'
        cv2.imwrite("results/siftTrackC" + str(saveCount) + ".jpg", imgC)
        cv2.imwrite("results/siftTrackB" + str(saveCount) + ".jpg", imgB)
        cv2.imwrite("results/siftTrackA" + str(saveCount) + ".jpg", imgA)

cap.release()
cv2.destroyAllWindows()